package celular.palavras;

/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Introducao a Programao
 * Projeto Celular
 *
 * Tipo:Palavra
 *
 * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
 * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
 * @author: Milena Rocha Leite          (mrl@cin.ufpe.br)
 *
 * @since 2002
 * @version 1.1
 */
import celular.util.Console;
import celular.util.excecoes.ParametroNuloException;

public abstract class Palavra {

  private String traducao;

  /**
   * Mtodo para a verificao de igualdade entre duas palavras
   *
   * @param  Object  palavra a ser comparada
   * @return boolean  boleano que indica se a palavra que chama o mtodo  igual
   *                  a palavra passada como parmetro
   */
  public abstract boolean equals(Object palavra) ;  
  /**
   * Mtodo que retorna a letra que est na posio passada como parmetro
   *
   * @param  int    posicao da letra procurada
   * @return char   retorna letra encontrada
   */
  public abstract char getLetra(int posicao);  
  /**
   * Mtodo que verifica se a palavra possui em determinada posicao um dos
   * caracteres passados
   *
   * @boolean retorno        retorna a verificacao
   */
  public abstract boolean temLetras(char[] letras, int posicaoAtual);  
  /**
   * Mtodo que imprime a palavra
   *
   * @return String quer representa a palavra a ser impressa
   */
  public abstract String toString() ;  
}
