package celular.palavras;

/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Introducao a Programao
 * Projeto Celular
 *
 * Tipo: PalavraSimples
 *
 * @author: Milena Rocha Leite          (mrl@cin.ufpe.br)
 *
 * @since 2002
 * @version 1.1
 */
import celular.util.excecoes.ParametroNuloException;
import celular.util.excecoes.ParametroInvalidoException;
import celular.util.Console;

public class PalavraSimples extends Palavra{

  private String palavra;
  

  /**
   * Construtor da classe PalavraSimples
   *
   * @param  String   palavra
   */
  public PalavraSimples(String palavra) {
	if (palavra != null){
	   this.setPalavra(palavra);
	
	} else {
	  throw new ParametroNuloException("A String passada como parametro estah nula");
	}
  }  
  /**
   * Mtodo para a verificao de igualdade entre duas palavras
   *
   * @param  Palavra  palavra a ser comparada
   * @return boolean  boleano que indica se a palavra que chama o mtodo  igual
   *                  a palavra passada como parmetro
   */
  public boolean equals(Object palavra){
	boolean retorno = false;
	PalavraSimples pal = null;

	if(palavra != null) {		
		if( palavra instanceof PalavraSimples){
			pal = (PalavraSimples)palavra;
			if (pal.getPalavra().equalsIgnoreCase(this.getPalavra())){
				  retorno = true;
			}
		}
	}	
	return retorno;
  }  
  /**
   * Mtodo que retorna a letra que est na posio passada como parmetro
   *
   * @param  int    posicao da letra procurada
   * @return char   retorna letra encontrada
   */
  public char getLetra(int posicao) {
	char letra = '\n';
	
	if(posicao >= 1) {
		if(palavra != null) {
	 	  if(posicao <= this.palavra.length() ) {
					  //eh posicao menos 1 pq charAt considera a primeira podsicao 0
	 		  letra = this.palavra.charAt(posicao-1);
	 	  }
		} else {
			throw new ParametroNuloException("A palavra concatenada estah nula");
		}
	} else {
		throw new ParametroInvalidoException("A posicao passada eh invalida");
	}		
	return letra;
 } 
  /**
   * Mtodo que retorna o valor do atributo palavra
   *
   * @return String  que representa o valor do atributo palavra
   */
  public String getPalavra(){
	return this.palavra;
  }  
  public static void main(String args[]) {

 	  PalavraSimples p = new PalavraSimples("milena");
		  System.out.println(p.getLetra(0));

  }  
  /**
   * Mtodo que atrinui um novo valor ao atributo palavra
   *
   * @param String nova palavra a ser alterada
   */
  public void setPalavra(String palavra) {
	 	
	if(palavra != null) {
		this.palavra = palavra;
	} else{
		throw new ParametroNuloException("A palavra concatenada estah nula");
	}		
  }  
  /**
   * Mtodo que verifica se a palavra possui em determinada posicao um dos
   * caracteres passados
   *
   * @boolean retorno        retorna a verificacao
   */
  public boolean temLetras(char[] letras, int posicao){
 	
 	boolean retorno = false;
	char l = this.getLetra(posicao);
	
	if(posicao >= 1) {
	 	if (l!='\n') {
	 	  for (int i = 0; i < letras.length && !retorno ; i++) {
				retorno = (l == letras[i]);
			  }
	 	}
	} else {
		throw new ParametroInvalidoException("A posicao passada eh invalida");		
	}		
 	return retorno;
 } 
 /**
  * Mtodo que imprime a palavra
  *
  * @return String quer representa a palavra a ser impressa
  */
  public String toString(){
	String palavra="";
	palavra = this.palavra;
	return palavra;
  }  
}
