package celular.palavras.dados;

/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Introducao a Programao
 * Projeto Celular
 *
 * Tipo: IteradorLista
 *
 * @author: Milena Rocha Leite     (mrl@cin.ufpe.br)
 *
 * @since 2002
 * @version 1.0
 */
import java.util.List;
import java.util.Iterator;
import celular.palavras.Palavra;

public class IteradorLista {

	private Iterator iterador;
	private List elementos;

	public IteradorLista(List elementos) {
		this.elementos = elementos;
		this.iterador = elementos.iterator();
	}
	/**
	 * Mtodo que retorna a proxima palavra da lista
	 *
	 * @return Palavra
	 */
	public Palavra proxima(){
	   Palavra retorno = null;
	   if(this.iterador.hasNext()){
		  retorno = (Palavra)iterador.next();
	   }
		return retorno;
	}
	/**
	 *  Mtodo que reseta o proxima de navegacao dentro da lista
	 */
	public void reset(){
		this.iterador = this.elementos.iterator();
	}
   /**
	 * Mtodo que retorna a proxima palavra da lista
	 *
	 * @return Palavra
	 */
	public boolean temProxima(){
	   boolean retorno = false;

	   if(this.iterador.hasNext()){
		  retorno = true;
	   }
		return retorno;
	}
}
